//sprite extracter for Williams video arcade games
//Sean Riddle 2007 members.cox.net/seanriddle
//rips sprites from Williams ROM images (Defender, Stargate, Robotron, Joust, Bubble, Sinistar, etc)

//possible to-do:
//external palette file; plain text with palette name and colors
//see if sprite descr already used
//snapshot - create jpeg of window

#pragma once

#include "descform.h"
#include "spritesform.h"

namespace wmsgfxripper {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form {
	private:
		array<Byte>^colors;
		array<Byte>^buffer;
		bool saved;
		ArrayList^ sprites;
		String^ spritefilename;
		String^ prevtext;

	public:
	Form1(void) {
		buffer=gcnew array<Byte>(65536);
		colors=gcnew array<Byte>(16);
		sprites=gcnew ArrayList();
		InitializeComponent();
		comboBoxPalette->SelectedIndex=1;
		comboBoxView->SelectedIndex=0;
		comboBoxLayout->SelectedIndex=0;
		comboBoxNumPrecedingBytes->SelectedIndex=2;
		trackBarZoom->Value=3;
		saved=true;

		//
		//TODO: Add the constructor code here
		//
	}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1() {
			if (components) {
				delete components;
			}
		}

	private: System::Windows::Forms::TextBox^  textBoxHexXORwh;
	private: System::Windows::Forms::TextBox^  textBoxHexwh;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Button^  buttonSkipXORwh;
	private: System::Windows::Forms::Button^  buttonSkipwh;
	private: System::Windows::Forms::ComboBox^  comboBoxNumPrecedingBytes;
	private: System::Windows::Forms::ComboBox^  comboBoxView;
	private: System::Windows::Forms::ComboBox^  comboBoxLayout;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::GroupBox^  groupBox3;
	private: System::Windows::Forms::GroupBox^  groupBox4;
	private: System::Windows::Forms::GroupBox^  groupBox5;
	private: System::Windows::Forms::ToolTip^  toolTip1;
	private: System::Windows::Forms::Button^  buttonBackNotEmpty;
	private: System::Windows::Forms::Button^  buttonFwdNotEmpty;
	private: System::Windows::Forms::Panel^  panel1;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::TrackBar^  trackBarZoom;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownWidth;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownHeight;
	private: System::Windows::Forms::Button^  buttonBackPage;
	private: System::Windows::Forms::Button^  buttonBackLine;
	private: System::Windows::Forms::Button^  buttonFwdPage;
	private: System::Windows::Forms::Button^  buttonFwdLine;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownOffset;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::CheckBox^  checkBoxHex;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownPalette;
	private: System::Windows::Forms::ComboBox^  comboBoxPalette;
	private: System::Windows::Forms::TextBox^  textBoxFilename;
	private: System::Windows::Forms::Button^  buttonBrowse;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Button^  buttonReset;
	private: System::Windows::Forms::Button^  buttonAdd;
	private: System::Windows::Forms::Button^  buttonLoad;
	private: System::Windows::Forms::Button^  buttonSave;
	private: System::Windows::Forms::Button^  buttonList;
	private: System::ComponentModel::IContainer^  components;
	private: System::Windows::Forms::Button^  buttonLoadwh;
	private: System::Windows::Forms::Button^  buttonLoadwhXOR;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->textBoxHexXORwh = (gcnew System::Windows::Forms::TextBox());
			this->textBoxHexwh = (gcnew System::Windows::Forms::TextBox());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->comboBoxNumPrecedingBytes = (gcnew System::Windows::Forms::ComboBox());
			this->buttonSkipXORwh = (gcnew System::Windows::Forms::Button());
			this->buttonSkipwh = (gcnew System::Windows::Forms::Button());
			this->buttonLoadwhXOR = (gcnew System::Windows::Forms::Button());
			this->buttonLoadwh = (gcnew System::Windows::Forms::Button());
			this->groupBox4 = (gcnew System::Windows::Forms::GroupBox());
			this->buttonBackNotEmpty = (gcnew System::Windows::Forms::Button());
			this->buttonFwdNotEmpty = (gcnew System::Windows::Forms::Button());
			this->numericUpDownOffset = (gcnew System::Windows::Forms::NumericUpDown());
			this->numericUpDownHeight = (gcnew System::Windows::Forms::NumericUpDown());
			this->numericUpDownWidth = (gcnew System::Windows::Forms::NumericUpDown());
			this->buttonReset = (gcnew System::Windows::Forms::Button());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->buttonBackPage = (gcnew System::Windows::Forms::Button());
			this->buttonBackLine = (gcnew System::Windows::Forms::Button());
			this->buttonFwdPage = (gcnew System::Windows::Forms::Button());
			this->buttonFwdLine = (gcnew System::Windows::Forms::Button());
			this->groupBox3 = (gcnew System::Windows::Forms::GroupBox());
			this->comboBoxPalette = (gcnew System::Windows::Forms::ComboBox());
			this->numericUpDownPalette = (gcnew System::Windows::Forms::NumericUpDown());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->buttonLoad = (gcnew System::Windows::Forms::Button());
			this->buttonAdd = (gcnew System::Windows::Forms::Button());
			this->buttonSave = (gcnew System::Windows::Forms::Button());
			this->buttonList = (gcnew System::Windows::Forms::Button());
			this->checkBoxHex = (gcnew System::Windows::Forms::CheckBox());
			this->textBoxFilename = (gcnew System::Windows::Forms::TextBox());
			this->buttonBrowse = (gcnew System::Windows::Forms::Button());
			this->trackBarZoom = (gcnew System::Windows::Forms::TrackBar());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->comboBoxView = (gcnew System::Windows::Forms::ComboBox());
			this->comboBoxLayout = (gcnew System::Windows::Forms::ComboBox());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->groupBox5 = (gcnew System::Windows::Forms::GroupBox());
			this->toolTip1 = (gcnew System::Windows::Forms::ToolTip(this->components));
			this->panel1->SuspendLayout();
			this->groupBox4->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownOffset))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownHeight))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownWidth))->BeginInit();
			this->groupBox3->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownPalette))->BeginInit();
			this->groupBox1->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->trackBarZoom))->BeginInit();
			this->groupBox2->SuspendLayout();
			this->groupBox5->SuspendLayout();
			this->SuspendLayout();
			// 
			// panel1
			// 
			this->panel1->BackColor = System::Drawing::Color::Black;
			this->panel1->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panel1->Controls->Add(this->textBoxHexXORwh);
			this->panel1->Controls->Add(this->textBoxHexwh);
			this->panel1->Controls->Add(this->label7);
			this->panel1->Controls->Add(this->comboBoxNumPrecedingBytes);
			this->panel1->Controls->Add(this->buttonSkipXORwh);
			this->panel1->Controls->Add(this->buttonSkipwh);
			this->panel1->Controls->Add(this->buttonLoadwhXOR);
			this->panel1->Controls->Add(this->buttonLoadwh);
			this->panel1->Location = System::Drawing::Point(12, 169);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(608, 512);
			this->panel1->TabIndex = 0;
			this->panel1->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &Form1::panel1_Paint);
			// 
			// textBoxHexXORwh
			// 
			this->textBoxHexXORwh->Location = System::Drawing::Point(464, 40);
			this->textBoxHexXORwh->Name = L"textBoxHexXORwh";
			this->textBoxHexXORwh->Size = System::Drawing::Size(75, 20);
			this->textBoxHexXORwh->TabIndex = 7;
			// 
			// textBoxHexwh
			// 
			this->textBoxHexwh->Location = System::Drawing::Point(310, 40);
			this->textBoxHexwh->Name = L"textBoxHexwh";
			this->textBoxHexwh->Size = System::Drawing::Size(75, 20);
			this->textBoxHexwh->TabIndex = 6;
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->ForeColor = System::Drawing::SystemColors::ActiveCaptionText;
			this->label7->Location = System::Drawing::Point(59, 16);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(74, 13);
			this->label7->TabIndex = 5;
			this->label7->Text = L"preceding info";
			// 
			// comboBoxNumPrecedingBytes
			// 
			this->comboBoxNumPrecedingBytes->FormattingEnabled = true;
			this->comboBoxNumPrecedingBytes->Items->AddRange(gcnew cli::array< System::Object^  >(9) {L"none", L"show 1 byte", L"show 2 bytes", 
				L"show 3 bytes", L"show 4 bytes", L"show 5 bytes", L"show 6 bytes", L"show 7 bytes", L"show 8 bytes"});
			this->comboBoxNumPrecedingBytes->Location = System::Drawing::Point(139, 13);
			this->comboBoxNumPrecedingBytes->Name = L"comboBoxNumPrecedingBytes";
			this->comboBoxNumPrecedingBytes->Size = System::Drawing::Size(92, 21);
			this->comboBoxNumPrecedingBytes->TabIndex = 4;
			this->comboBoxNumPrecedingBytes->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::comboBoxNumPrecedingBytes_SelectedIndexChanged);
			// 
			// buttonSkipXORwh
			// 
			this->buttonSkipXORwh->Location = System::Drawing::Point(511, 11);
			this->buttonSkipXORwh->Name = L"buttonSkipXORwh";
			this->buttonSkipXORwh->Size = System::Drawing::Size(83, 23);
			this->buttonSkipXORwh->TabIndex = 3;
			this->buttonSkipXORwh->Text = L"skip XOR w*h";
			this->buttonSkipXORwh->UseVisualStyleBackColor = true;
			this->buttonSkipXORwh->Click += gcnew System::EventHandler(this, &Form1::buttonSkipXORwh_Click);
			// 
			// buttonSkipwh
			// 
			this->buttonSkipwh->Location = System::Drawing::Point(352, 11);
			this->buttonSkipwh->Name = L"buttonSkipwh";
			this->buttonSkipwh->Size = System::Drawing::Size(57, 23);
			this->buttonSkipwh->TabIndex = 2;
			this->buttonSkipwh->Text = L"skip w*h";
			this->buttonSkipwh->UseVisualStyleBackColor = true;
			this->buttonSkipwh->Click += gcnew System::EventHandler(this, &Form1::buttonSkipwh_Click);
			// 
			// buttonLoadwhXOR
			// 
			this->buttonLoadwhXOR->Location = System::Drawing::Point(417, 11);
			this->buttonLoadwhXOR->Name = L"buttonLoadwhXOR";
			this->buttonLoadwhXOR->Size = System::Drawing::Size(85, 23);
			this->buttonLoadwhXOR->TabIndex = 1;
			this->buttonLoadwhXOR->Text = L"load XOR w&&h";
			this->buttonLoadwhXOR->UseVisualStyleBackColor = true;
			this->buttonLoadwhXOR->Click += gcnew System::EventHandler(this, &Form1::buttonLoadwhXOR_Click);
			// 
			// buttonLoadwh
			// 
			this->buttonLoadwh->Location = System::Drawing::Point(285, 11);
			this->buttonLoadwh->Name = L"buttonLoadwh";
			this->buttonLoadwh->Size = System::Drawing::Size(59, 23);
			this->buttonLoadwh->TabIndex = 0;
			this->buttonLoadwh->Text = L"load w&&h";
			this->buttonLoadwh->UseVisualStyleBackColor = true;
			this->buttonLoadwh->Click += gcnew System::EventHandler(this, &Form1::buttonLoadwh_Click);
			// 
			// groupBox4
			// 
			this->groupBox4->Controls->Add(this->buttonBackNotEmpty);
			this->groupBox4->Controls->Add(this->buttonFwdNotEmpty);
			this->groupBox4->Controls->Add(this->numericUpDownOffset);
			this->groupBox4->Controls->Add(this->numericUpDownHeight);
			this->groupBox4->Controls->Add(this->numericUpDownWidth);
			this->groupBox4->Controls->Add(this->buttonReset);
			this->groupBox4->Controls->Add(this->label4);
			this->groupBox4->Controls->Add(this->label5);
			this->groupBox4->Controls->Add(this->label6);
			this->groupBox4->Controls->Add(this->label1);
			this->groupBox4->Controls->Add(this->label2);
			this->groupBox4->Controls->Add(this->label3);
			this->groupBox4->Controls->Add(this->buttonBackPage);
			this->groupBox4->Controls->Add(this->buttonBackLine);
			this->groupBox4->Controls->Add(this->buttonFwdPage);
			this->groupBox4->Controls->Add(this->buttonFwdLine);
			this->groupBox4->Location = System::Drawing::Point(144, 44);
			this->groupBox4->Name = L"groupBox4";
			this->groupBox4->Size = System::Drawing::Size(254, 115);
			this->groupBox4->TabIndex = 33;
			this->groupBox4->TabStop = false;
			this->groupBox4->Text = L"Memory";
			// 
			// buttonBackNotEmpty
			// 
			this->buttonBackNotEmpty->Location = System::Drawing::Point(32, 88);
			this->buttonBackNotEmpty->Name = L"buttonBackNotEmpty";
			this->buttonBackNotEmpty->Size = System::Drawing::Size(35, 23);
			this->buttonBackNotEmpty->TabIndex = 32;
			this->buttonBackNotEmpty->Text = L"|<";
			this->toolTip1->SetToolTip(this->buttonBackNotEmpty, L"Skip back until not 00 or FF");
			this->buttonBackNotEmpty->UseVisualStyleBackColor = true;
			this->buttonBackNotEmpty->Click += gcnew System::EventHandler(this, &Form1::buttonBackNotEmpty_Click);
			// 
			// buttonFwdNotEmpty
			// 
			this->buttonFwdNotEmpty->Location = System::Drawing::Point(188, 87);
			this->buttonFwdNotEmpty->Name = L"buttonFwdNotEmpty";
			this->buttonFwdNotEmpty->Size = System::Drawing::Size(35, 23);
			this->buttonFwdNotEmpty->TabIndex = 31;
			this->buttonFwdNotEmpty->Text = L">|";
			this->toolTip1->SetToolTip(this->buttonFwdNotEmpty, L"Skip forward until not 00 or FF");
			this->buttonFwdNotEmpty->UseVisualStyleBackColor = true;
			this->buttonFwdNotEmpty->Click += gcnew System::EventHandler(this, &Form1::buttonFwdNotEmpty_Click);
			// 
			// numericUpDownOffset
			// 
			this->numericUpDownOffset->Location = System::Drawing::Point(102, 64);
			this->numericUpDownOffset->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {65535, 0, 0, 0});
			this->numericUpDownOffset->Name = L"numericUpDownOffset";
			this->numericUpDownOffset->Size = System::Drawing::Size(60, 20);
			this->numericUpDownOffset->TabIndex = 16;
			this->numericUpDownOffset->ValueChanged += gcnew System::EventHandler(this, &Form1::numericUpDownOffset_ValueChanged);
			// 
			// numericUpDownHeight
			// 
			this->numericUpDownHeight->Location = System::Drawing::Point(186, 20);
			this->numericUpDownHeight->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {256, 0, 0, 0});
			this->numericUpDownHeight->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->numericUpDownHeight->Name = L"numericUpDownHeight";
			this->numericUpDownHeight->Size = System::Drawing::Size(52, 20);
			this->numericUpDownHeight->TabIndex = 8;
			this->numericUpDownHeight->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {32, 0, 0, 0});
			this->numericUpDownHeight->ValueChanged += gcnew System::EventHandler(this, &Form1::numericUpDownHeight_ValueChanged);
			// 
			// numericUpDownWidth
			// 
			this->numericUpDownWidth->Location = System::Drawing::Point(103, 20);
			this->numericUpDownWidth->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {152, 0, 0, 0});
			this->numericUpDownWidth->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->numericUpDownWidth->Name = L"numericUpDownWidth";
			this->numericUpDownWidth->Size = System::Drawing::Size(52, 20);
			this->numericUpDownWidth->TabIndex = 6;
			this->numericUpDownWidth->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {32, 0, 0, 0});
			this->numericUpDownWidth->ValueChanged += gcnew System::EventHandler(this, &Form1::numericUpDownWidth_ValueChanged);
			// 
			// buttonReset
			// 
			this->buttonReset->Location = System::Drawing::Point(12, 18);
			this->buttonReset->Name = L"buttonReset";
			this->buttonReset->Size = System::Drawing::Size(75, 23);
			this->buttonReset->TabIndex = 30;
			this->buttonReset->Text = L"Reset";
			this->buttonReset->UseVisualStyleBackColor = true;
			this->buttonReset->Click += gcnew System::EventHandler(this, &Form1::button7_Click);
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(92, 22);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(0, 13);
			this->label4->TabIndex = 19;
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(175, 22);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(0, 13);
			this->label5->TabIndex = 20;
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(91, 66);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(0, 13);
			this->label6->TabIndex = 21;
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(112, 42);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(35, 13);
			this->label1->TabIndex = 7;
			this->label1->Text = L"Width";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(193, 41);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(38, 13);
			this->label2->TabIndex = 9;
			this->label2->Text = L"Height";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(110, 86);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(35, 13);
			this->label3->TabIndex = 17;
			this->label3->Text = L"Offset";
			// 
			// buttonBackPage
			// 
			this->buttonBackPage->Location = System::Drawing::Point(12, 62);
			this->buttonBackPage->Name = L"buttonBackPage";
			this->buttonBackPage->Size = System::Drawing::Size(35, 23);
			this->buttonBackPage->TabIndex = 10;
			this->buttonBackPage->Text = L"<<";
			this->toolTip1->SetToolTip(this->buttonBackPage, L"Skip back one page");
			this->buttonBackPage->UseVisualStyleBackColor = true;
			this->buttonBackPage->Click += gcnew System::EventHandler(this, &Form1::buttonBackPage_Click);
			// 
			// buttonBackLine
			// 
			this->buttonBackLine->Location = System::Drawing::Point(52, 62);
			this->buttonBackLine->Name = L"buttonBackLine";
			this->buttonBackLine->Size = System::Drawing::Size(35, 23);
			this->buttonBackLine->TabIndex = 11;
			this->buttonBackLine->Text = L"<";
			this->toolTip1->SetToolTip(this->buttonBackLine, L"Skip back one line");
			this->buttonBackLine->UseVisualStyleBackColor = true;
			this->buttonBackLine->Click += gcnew System::EventHandler(this, &Form1::buttonBackLine_Click);
			// 
			// buttonFwdPage
			// 
			this->buttonFwdPage->Location = System::Drawing::Point(208, 62);
			this->buttonFwdPage->Name = L"buttonFwdPage";
			this->buttonFwdPage->Size = System::Drawing::Size(35, 23);
			this->buttonFwdPage->TabIndex = 15;
			this->buttonFwdPage->Text = L">>";
			this->toolTip1->SetToolTip(this->buttonFwdPage, L"Skip forward one page");
			this->buttonFwdPage->UseVisualStyleBackColor = true;
			this->buttonFwdPage->Click += gcnew System::EventHandler(this, &Form1::buttonFwdPage_Click);
			// 
			// buttonFwdLine
			// 
			this->buttonFwdLine->Location = System::Drawing::Point(167, 62);
			this->buttonFwdLine->Name = L"buttonFwdLine";
			this->buttonFwdLine->Size = System::Drawing::Size(35, 23);
			this->buttonFwdLine->TabIndex = 14;
			this->buttonFwdLine->Text = L">";
			this->toolTip1->SetToolTip(this->buttonFwdLine, L"Skip forward one line");
			this->buttonFwdLine->UseVisualStyleBackColor = true;
			this->buttonFwdLine->Click += gcnew System::EventHandler(this, &Form1::buttonFwdLine_Click);
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->comboBoxPalette);
			this->groupBox3->Controls->Add(this->numericUpDownPalette);
			this->groupBox3->Controls->Add(this->label9);
			this->groupBox3->Location = System::Drawing::Point(404, 44);
			this->groupBox3->Name = L"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(98, 115);
			this->groupBox3->TabIndex = 33;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = L"Palette";
			// 
			// comboBoxPalette
			// 
			this->comboBoxPalette->Items->AddRange(gcnew cli::array< System::Object^  >(11) {L"From Memory", L"Reset", L"Joust", L"Sinistar", 
				L"Bubbles", L"Defender", L"Splat", L"Robotron", L"Def Reset", L"False Color", L"Def 2"});
			this->comboBoxPalette->Location = System::Drawing::Point(5, 29);
			this->comboBoxPalette->Name = L"comboBoxPalette";
			this->comboBoxPalette->Size = System::Drawing::Size(88, 21);
			this->comboBoxPalette->TabIndex = 24;
			this->toolTip1->SetToolTip(this->comboBoxPalette, L"Choose a color palette");
			this->comboBoxPalette->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::comboBoxPalette_SelectedIndexChanged);
			// 
			// numericUpDownPalette
			// 
			this->numericUpDownPalette->Location = System::Drawing::Point(24, 64);
			this->numericUpDownPalette->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {65535, 0, 0, 0});
			this->numericUpDownPalette->Name = L"numericUpDownPalette";
			this->numericUpDownPalette->Size = System::Drawing::Size(60, 20);
			this->numericUpDownPalette->TabIndex = 22;
			this->toolTip1->SetToolTip(this->numericUpDownPalette, L"Palette offset in memory");
			this->numericUpDownPalette->ValueChanged += gcnew System::EventHandler(this, &Form1::numericUpDownPalette_ValueChanged);
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(13, 65);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(0, 13);
			this->label9->TabIndex = 28;
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->buttonLoad);
			this->groupBox1->Controls->Add(this->buttonAdd);
			this->groupBox1->Controls->Add(this->buttonSave);
			this->groupBox1->Controls->Add(this->buttonList);
			this->groupBox1->Location = System::Drawing::Point(508, 44);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(114, 115);
			this->groupBox1->TabIndex = 43;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Sprites";
			// 
			// buttonLoad
			// 
			this->buttonLoad->Location = System::Drawing::Point(62, 28);
			this->buttonLoad->Name = L"buttonLoad";
			this->buttonLoad->Size = System::Drawing::Size(45, 23);
			this->buttonLoad->TabIndex = 34;
			this->buttonLoad->Text = L"Load";
			this->toolTip1->SetToolTip(this->buttonLoad, L"Load sprite list");
			this->buttonLoad->UseVisualStyleBackColor = true;
			this->buttonLoad->Click += gcnew System::EventHandler(this, &Form1::buttonLoad_Click);
			// 
			// buttonAdd
			// 
			this->buttonAdd->Location = System::Drawing::Point(11, 28);
			this->buttonAdd->Name = L"buttonAdd";
			this->buttonAdd->Size = System::Drawing::Size(45, 23);
			this->buttonAdd->TabIndex = 33;
			this->buttonAdd->Text = L"Add";
			this->toolTip1->SetToolTip(this->buttonAdd, L"Add current sprite to list");
			this->buttonAdd->UseVisualStyleBackColor = true;
			this->buttonAdd->Click += gcnew System::EventHandler(this, &Form1::buttonAdd_Click);
			// 
			// buttonSave
			// 
			this->buttonSave->Location = System::Drawing::Point(62, 62);
			this->buttonSave->Name = L"buttonSave";
			this->buttonSave->Size = System::Drawing::Size(45, 23);
			this->buttonSave->TabIndex = 35;
			this->buttonSave->Text = L"Save";
			this->toolTip1->SetToolTip(this->buttonSave, L"Save sprite list");
			this->buttonSave->UseVisualStyleBackColor = true;
			this->buttonSave->Click += gcnew System::EventHandler(this, &Form1::buttonSave_Click);
			// 
			// buttonList
			// 
			this->buttonList->Location = System::Drawing::Point(11, 62);
			this->buttonList->Name = L"buttonList";
			this->buttonList->Size = System::Drawing::Size(45, 23);
			this->buttonList->TabIndex = 36;
			this->buttonList->Text = L"List";
			this->toolTip1->SetToolTip(this->buttonList, L"Show sprite list");
			this->buttonList->UseVisualStyleBackColor = true;
			this->buttonList->Click += gcnew System::EventHandler(this, &Form1::buttonList_Click);
			// 
			// checkBoxHex
			// 
			this->checkBoxHex->AutoSize = true;
			this->checkBoxHex->Location = System::Drawing::Point(43, 129);
			this->checkBoxHex->Name = L"checkBoxHex";
			this->checkBoxHex->Size = System::Drawing::Size(45, 17);
			this->checkBoxHex->TabIndex = 18;
			this->checkBoxHex->Text = L"Hex";
			this->toolTip1->SetToolTip(this->checkBoxHex, L"Display values in hex or decimal");
			this->checkBoxHex->UseVisualStyleBackColor = true;
			this->checkBoxHex->CheckedChanged += gcnew System::EventHandler(this, &Form1::checkBoxHex_CheckedChanged);
			// 
			// textBoxFilename
			// 
			this->textBoxFilename->Location = System::Drawing::Point(16, 14);
			this->textBoxFilename->Name = L"textBoxFilename";
			this->textBoxFilename->ReadOnly = true;
			this->textBoxFilename->Size = System::Drawing::Size(359, 20);
			this->textBoxFilename->TabIndex = 25;
			// 
			// buttonBrowse
			// 
			this->buttonBrowse->Location = System::Drawing::Point(389, 12);
			this->buttonBrowse->Name = L"buttonBrowse";
			this->buttonBrowse->Size = System::Drawing::Size(75, 23);
			this->buttonBrowse->TabIndex = 26;
			this->buttonBrowse->Text = L"Browse";
			this->toolTip1->SetToolTip(this->buttonBrowse, L"Load a ROM file");
			this->buttonBrowse->UseVisualStyleBackColor = true;
			this->buttonBrowse->Click += gcnew System::EventHandler(this, &Form1::buttonBrowse_Click);
			// 
			// trackBarZoom
			// 
			this->trackBarZoom->LargeChange = 1;
			this->trackBarZoom->Location = System::Drawing::Point(6, 75);
			this->trackBarZoom->Maximum = 5;
			this->trackBarZoom->Minimum = 1;
			this->trackBarZoom->Name = L"trackBarZoom";
			this->trackBarZoom->Size = System::Drawing::Size(119, 45);
			this->trackBarZoom->TabIndex = 31;
			this->trackBarZoom->Value = 1;
			this->trackBarZoom->Scroll += gcnew System::EventHandler(this, &Form1::trackBarZoom_Scroll);
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(51, 107);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(32, 13);
			this->label10->TabIndex = 32;
			this->label10->Text = L"zoom";
			// 
			// comboBoxView
			// 
			this->comboBoxView->FormattingEnabled = true;
			this->comboBoxView->Items->AddRange(gcnew cli::array< System::Object^  >(4) {L"Memory", L"Sprites", L"Palette", L"Hex"});
			this->comboBoxView->Location = System::Drawing::Point(37, 48);
			this->comboBoxView->Name = L"comboBoxView";
			this->comboBoxView->Size = System::Drawing::Size(68, 21);
			this->comboBoxView->TabIndex = 40;
			this->toolTip1->SetToolTip(this->comboBoxView, L"Display sprites from memory or list, or palette");
			this->comboBoxView->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::comboBoxView_SelectedIndexChanged);
			// 
			// comboBoxLayout
			// 
			this->comboBoxLayout->FormattingEnabled = true;
			this->comboBoxLayout->Items->AddRange(gcnew cli::array< System::Object^  >(2) {L"Linear", L"Screen"});
			this->comboBoxLayout->Location = System::Drawing::Point(37, 21);
			this->comboBoxLayout->Name = L"comboBoxLayout";
			this->comboBoxLayout->Size = System::Drawing::Size(68, 21);
			this->comboBoxLayout->TabIndex = 42;
			this->toolTip1->SetToolTip(this->comboBoxLayout, L"Choose sprite layout");
			this->comboBoxLayout->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::comboBoxLayout_SelectedIndexChanged);
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->label10);
			this->groupBox2->Controls->Add(this->comboBoxLayout);
			this->groupBox2->Controls->Add(this->comboBoxView);
			this->groupBox2->Controls->Add(this->trackBarZoom);
			this->groupBox2->Controls->Add(this->checkBoxHex);
			this->groupBox2->Location = System::Drawing::Point(10, 8);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(128, 151);
			this->groupBox2->TabIndex = 44;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"View";
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->buttonBrowse);
			this->groupBox5->Controls->Add(this->textBoxFilename);
			this->groupBox5->Location = System::Drawing::Point(145, 2);
			this->groupBox5->Name = L"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(477, 41);
			this->groupBox5->TabIndex = 45;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = L"File";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(631, 690);
			this->Controls->Add(this->panel1);
			this->Controls->Add(this->groupBox4);
			this->Controls->Add(this->groupBox3);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->groupBox5);
			this->Controls->Add(this->groupBox2);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::Fixed3D;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"Form1";
			this->Text = L"Wms Gfx Ripper - Sean Riddle - members.cox.net/seanriddle";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			this->panel1->ResumeLayout(false);
			this->panel1->PerformLayout();
			this->groupBox4->ResumeLayout(false);
			this->groupBox4->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownOffset))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownHeight))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownWidth))->EndInit();
			this->groupBox3->ResumeLayout(false);
			this->groupBox3->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->numericUpDownPalette))->EndInit();
			this->groupBox1->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->trackBarZoom))->EndInit();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->groupBox5->ResumeLayout(false);
			this->groupBox5->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion

	private: System::Void checkBoxHex_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		numericUpDownWidth->Hexadecimal=checkBoxHex->Checked; //width
		numericUpDownHeight->Hexadecimal=checkBoxHex->Checked; //height
		numericUpDownOffset->Hexadecimal=checkBoxHex->Checked; //offset
		numericUpDownPalette->Hexadecimal=checkBoxHex->Checked; //pal addr
		label4->Text=checkBoxHex->Checked?"$":"";
		label5->Text=label4->Text;
		label6->Text=label4->Text;
		label9->Text=label4->Text;
	}


	private: System::Void button7_Click(System::Object^  sender, System::EventArgs^  e) {
		Graphics^ gr=panel1->CreateGraphics();
		gr->Clear(Color::Black);
		numericUpDownOffset->Value=0;
		numericUpDownHeight->Value=32;
		numericUpDownWidth->Value=32;
	}


	private: System::Void buttonBackPage_Click(System::Object^  sender, System::EventArgs^  e) {	//up page
		int cwidth;
		int cheight;
		int coffset=Convert::ToInt32(numericUpDownOffset->Value);
		if(comboBoxView->SelectedIndex==3) {
			cwidth=buffer[coffset-2];
			cheight=buffer[coffset-1];
		} else {
			cwidth=Convert::ToInt32(numericUpDownWidth->Value);
			cheight=Convert::ToInt32(numericUpDownHeight->Value);
		}
        coffset-=cwidth*cheight;
        if(coffset<0)
			coffset+=65536;
		numericUpDownOffset->Value=coffset;
	}


	private: System::Void buttonFwdPage_Click(System::Object^  sender, System::EventArgs^  e) { //down page
		int cwidth;
		int cheight;
		int coffset=Convert::ToInt32(numericUpDownOffset->Value);
		if(comboBoxView->SelectedIndex==3) {
			cwidth=buffer[coffset-2];
			cheight=buffer[coffset-1];
		} else {
			cwidth=Convert::ToInt32(numericUpDownWidth->Value);
			cheight=Convert::ToInt32(numericUpDownHeight->Value);
		}
        coffset+=cwidth*cheight;
        if(coffset>65535)
			coffset-=65536;
		numericUpDownOffset->Value=coffset;
	}


	private: System::Void buttonBackLine_Click(System::Object^  sender, System::EventArgs^  e) { //up line
		int cwidth=Convert::ToInt32(numericUpDownWidth->Value);
		int coffset=Convert::ToInt32(numericUpDownOffset->Value);
		int cheight=Convert::ToInt32(numericUpDownHeight->Value);
		if(comboBoxLayout->SelectedIndex==0)
			coffset-=cwidth;
		else
			coffset-=cheight;
        if(coffset<0)
			coffset+=65536;
		numericUpDownOffset->Value=coffset;
	}


	private: System::Void buttonFwdLine_Click(System::Object^  sender, System::EventArgs^  e) { //down line
		int cwidth=Convert::ToInt32(numericUpDownWidth->Value);
		int coffset=Convert::ToInt32(numericUpDownOffset->Value);
		int cheight=Convert::ToInt32(numericUpDownHeight->Value);
		if(comboBoxLayout->SelectedIndex==0)
			coffset+=cwidth;
		else
			coffset+=cheight;
        if(coffset>65535)
			coffset-=65536;
		numericUpDownOffset->Value=coffset;
	}


	private: System::Void comboBoxPalette_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) { //palette type
		unsigned char gamecolors[10][16]={    /* Reset, Joust, Sin,Bub,def,splat,robo,...defreset,false color, def2, (Custom) */
		    0x00,0xf9,0x07,0x28,0x2f,0x00,0xa4,0x15,0xc7,0xff,0x38,0x17,0xcc,0x81,0x81,0x2f, //reset
			0x00,0xff,0x70,0x58,0x0f,0x3f,0x51,0xe8,0x14,0x90,0x5d,0x11,0x1f,0xa4,0x0a,0x67, //Joust @e5fa
			0x00,0xff,0xbf,0xae,0xad,0xa4,0x9a,0x00,0x00,0xc9,0x50,0x4b,0x05,0x07,0x00,0x37, //Sinistar @50cb
			0xc9,0xff,0x2f,0x1f,0x06,0x0a,0xda,0xac,0x80,0x00,0xf0,0xc5,0x53,0x92,0xa6,0x00, //Bubbles @0d7f
			0x00,0x00,0x07,0x28,0x2f,0x81,0xa4,0x15,0xc7,0xff,0x00,0x00,0x00,0x00,0x00,0x00, //Defender @f8be
			0x00,0xff,0x2f,0x5f,0x0f,0x18,0xe0,0x0c,0xd0,0x16,0x4a,0x52,0x04,0x9c,0x02,0x80, //Splat @dd2f
			0x00,0x07,0x17,0xc7,0x1f,0x3f,0x38,0xc0,0xa4,0xff,0x38,0x17,0xcc,0x81,0x81,0x07, //Robotron @da51

			0xc0,0x87,0x5f,0x43,0x2f,0x21,0x17,0x10,0x0b,0x07,0x04,0x02,0x01,0x00,0x00,0x00, //def reset
			0x00,0x52,0xa4,0xff,0x02,0x04,0x07,0x10,0x20,0x38,0x40,0x80,0xc0,0x3f,0xc7,0xf8, //false color
			0x00,0x52,0x07,0x28,0x2f,0x81,0xa4,0x15,0xc7,0xff,0x24,0x3f,0xf8,0x04,0xa0,0x87, //defender w/more colors
		};
		if(comboBoxPalette->SelectedIndex==0) {
			numericUpDownPalette->Enabled=true;
			//read palette from ROM
			for(int i=0;i<16;i++)
				if(Convert::ToInt32(numericUpDownPalette->Value)+i<65536)
					colors[i]=buffer[Convert::ToInt32(numericUpDownPalette->Value)+i];
				else
					colors[i]=buffer[Convert::ToInt32(numericUpDownPalette->Value)+i-65536];
		} else {
			numericUpDownPalette->Enabled=false;
			for(int i=0;i<16;i++)
				colors[i]=gamecolors[comboBoxPalette->SelectedIndex-1][i];
		}
		panel1->Invalidate();
	}


	private: System::Void buttonBrowse_Click(System::Object^  sender, System::EventArgs^  e) {
		Cursor=System::Windows::Forms::Cursors::WaitCursor;
		OpenFileDialog^ openFileDialog1 = gcnew OpenFileDialog();
		openFileDialog1->Title="Select ROM file";
//		openFileDialog1->InitialDirectory = projectDirectory ;
		openFileDialog1->Filter = "Binary files (*.bin)|*.bin|All files (*.*)|*.*" ;
		openFileDialog1->FilterIndex = 1;
		openFileDialog1->RestoreDirectory = true;

		if(openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
			textBoxFilename->Text=openFileDialog1->FileName;
			readfile(openFileDialog1->FileName,buffer);
		}
		openFileDialog1=nullptr;
		Cursor=System::Windows::Forms::Cursors::Arrow;
		panel1->Invalidate();
	}


	private: System::Void numericUpDownWidth_ValueChanged(System::Object^  sender, System::EventArgs^  e) {
		panel1->Invalidate();
	}


	private: System::Void numericUpDownHeight_ValueChanged(System::Object^  sender, System::EventArgs^  e) {
		panel1->Invalidate();
	}


	private: System::Void numericUpDownPalette_ValueChanged(System::Object^  sender, System::EventArgs^  e) {
		comboBoxPalette_SelectedIndexChanged(sender,e);
	}


	private: System::Void numericUpDownOffset_ValueChanged(System::Object^  sender, System::EventArgs^  e) {
		panel1->Invalidate();
	}


	void drawsprite(Graphics^ gr, int offset, int width, int height,int top, int left,bool linear, int zoom) {
		int byte;
		Brush^ pixelbrush;
		unsigned char r,g,b;
		array<PointF>^points=gcnew array<PointF>(5);

		for(int y=0;y<height;y++) {
			for(int x=0;x<width;x++) {
				if(linear)
					byte=offset+width*y+x;
				else
					byte=offset+height*x+y;
            
				if((byte>=0)&&(byte<65536)) {
					//get color from color table
					r=(colors[(buffer[byte]>>4)&0xf]&0x7)<<1;
					if(r>6)
						r++;
					g=(colors[(buffer[byte]>>4)&0xf]&0x38)>>2;
					if(g>6)
						g++;
					b=((colors[(buffer[byte]>>4)&0xf]&0xc0)>>6)*5;
					pixelbrush=gcnew SolidBrush(Color::FromArgb(255,r<<4|r,g<<4|g,b<<4|b));
				} else
					pixelbrush=gcnew SolidBrush(Color::Black);
				points[0].X=static_cast<float>((left+x*2)*zoom);
				points[0].Y=static_cast<float>((top+y)*zoom);
				points[1].X=static_cast<float>((left+x*2)*zoom+zoom);
				points[1].Y=static_cast<float>((top+y)*zoom);
				points[2].X=static_cast<float>((left+x*2)*zoom+zoom);
				points[2].Y=static_cast<float>((top+y)*zoom+zoom);
				points[3].X=static_cast<float>((left+x*2)*zoom);
				points[3].Y=static_cast<float>((top+y)*zoom+zoom);
				points[4].X=static_cast<float>((left+x*2)*zoom);
				points[4].Y=static_cast<float>((top+y)*zoom);
				gr->FillPolygon(pixelbrush,points);

				if((byte>=0)&&(byte<65536)) {
					//get color from color table
					r=(colors[(buffer[byte])&0xf]&0x7)<<1;
					if(r>6)
						r++;
					g=(colors[(buffer[byte])&0xf]&0x38)>>2;
					if(g>6)
						g++;
					b=((colors[(buffer[byte])&0xf]&0xc0)>>6)*5;
					pixelbrush=gcnew SolidBrush(Color::FromArgb(255,r<<4|r,g<<4|g,b<<4|b));
				} else
					pixelbrush=gcnew SolidBrush(Color::Black);
				points[0].X=static_cast<float>((left+x*2+1)*zoom);
				points[0].Y=static_cast<float>((top+y)*zoom);
				points[1].X=static_cast<float>((left+x*2+1)*zoom+zoom);
				points[1].Y=static_cast<float>((top+y)*zoom);
				points[2].X=static_cast<float>((left+x*2+1)*zoom+zoom);
				points[2].Y=static_cast<float>((top+y)*zoom+zoom);
				points[3].X=static_cast<float>((left+x*2+1)*zoom);
				points[3].Y=static_cast<float>((top+y)*zoom+zoom);
				points[4].X=static_cast<float>((left+x*2+1)*zoom);
				points[4].Y=static_cast<float>((top+y)*zoom);
				gr->FillPolygon(pixelbrush,points);
			}
		}
	}


	void Form1::readfile(String^ file,array<Byte>^ buffer) {
	   try {
		   FileStream^ fstrm=gcnew FileStream(file,FileMode::Open,FileAccess::Read);
		   BinaryReader^ binr=gcnew BinaryReader(fstrm);
		   binr->Read(buffer,0,65536);
		   binr->Close();
	   } catch(System::Exception^ exp) {
		   MessageBox::Show(this,exp->Message);
	   }
	}


	private: System::Void trackBarZoom_Scroll(System::Object^  sender, System::EventArgs^  e) {
		panel1->Invalidate();
	}


	private: System::Void buttonAdd_Click(System::Object^  sender, System::EventArgs^  e) { //add
		//see if offset already in list
		for(int i=0;i<sprites->Count;i++)
			if(Convert::ToInt32(sprites[i]->ToString()->Substring(51,5))==numericUpDownOffset->Value)
				if(MessageBox::Show(String::Concat("That offset is already in the list.  Add anyway?\n",sprites[i]->ToString()->Substring(0,50)->TrimEnd()," (",Convert::ToString(Convert::ToInt32(sprites[i]->ToString()->Substring(57,3))),", ",Convert::ToString(Convert::ToInt32(sprites[i]->ToString()->Substring(61,3))),")"),"Wms Gfx Ripper",MessageBoxButtons::YesNo,MessageBoxIcon::Question)==Windows::Forms::DialogResult::No)
					return;
		//ask for description
		//store desc, offset, width, height, layout
		descform^ descbox=gcnew descform(prevtext);
		if(descbox->ShowDialog()==Windows::Forms::DialogResult::OK) {
			prevtext=descbox->desctext->PadRight(50);
			sprites->Add(String::Concat(prevtext," ",Convert::ToString(numericUpDownOffset->Value)->PadRight(5)," ",Convert::ToString(numericUpDownWidth->Value)->PadRight(3)," ",Convert::ToString(numericUpDownHeight->Value)->PadRight(3),(comboBoxLayout->SelectedIndex==0?" L":" S")));
			saved=false;
		}
		panel1->Invalidate();
	}


	private: System::Void buttonList_Click(System::Object^  sender, System::EventArgs^  e) {
		bool doit=true;
		while(doit) {	//keep looping if deleting
			spritesform^ spritesbox=gcnew spritesform(sprites);
			doit=false;
			Windows::Forms::DialogResult dr=spritesbox->ShowDialog();
			if(dr==Windows::Forms::DialogResult::OK) {
				if(spritesbox->selectedsprite>-1) {
					int i=spritesbox->selectedsprite;
					int width=Convert::ToInt32(sprites[i]->ToString()->Substring(57,3));
					int offset=Convert::ToInt32(sprites[i]->ToString()->Substring(51,5));
					int height=Convert::ToInt32(sprites[i]->ToString()->Substring(61,3));
					numericUpDownWidth->Value=width;
					numericUpDownHeight->Value=height;
					numericUpDownOffset->Value=offset;
					comboBoxLayout->SelectedIndex=sprites[i]->ToString()->Substring(65,1)=="L"?0:1;
					if(comboBoxView->SelectedIndex==0) {
						Graphics^ gr=panel1->CreateGraphics();
						gr->Clear(Color::Black);
						drawsprite(gr,offset,width,height,0,0,sprites[i]->ToString()->Substring(65,1)=="L",trackBarZoom->Value);
					}
				}
			} else if(dr==Windows::Forms::DialogResult::Abort) {
				doit=true;
				if(spritesbox->selectedsprite>-1) {
					sprites->RemoveAt(spritesbox->selectedsprite);
					saved=false;
				}
			} else if(dr==Windows::Forms::DialogResult::Retry) {
				doit=true;
				if(MessageBox::Show("Are you sure you want to clear the sprite list?","Wms Gfx Ripper",MessageBoxButtons::YesNo,MessageBoxIcon::Question)==Windows::Forms::DialogResult::Yes) {
					sprites->Clear();
					saved=false;
				}
			}
		}
		panel1->Invalidate();
	}


	private: System::Void buttonLoad_Click(System::Object^  sender, System::EventArgs^  e) { //load sprite file
		 if(!saved) {
			 if(MessageBox::Show("Sprite list has not been saved.  Continue with load?","Wms Gfx Ripper",MessageBoxButtons::YesNo,MessageBoxIcon::Question)==Windows::Forms::DialogResult::No)
				 return;
		 }
		//load palette info, sprites
		Cursor=System::Windows::Forms::Cursors::WaitCursor;
		OpenFileDialog^ openFileDialog1 = gcnew OpenFileDialog();
		openFileDialog1->Title="Select sprite file";
		openFileDialog1->InitialDirectory = Path::GetDirectoryName(spritefilename);
		openFileDialog1->FileName=Path::GetFileName(spritefilename);
		openFileDialog1->Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*" ;
		openFileDialog1->FilterIndex = 1;
		openFileDialog1->RestoreDirectory = true;

		if(openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
			spritefilename=openFileDialog1->FileName;
			try {
				FileStream^ fstrm=gcnew FileStream(spritefilename,FileMode::Open);
				StreamReader^ rd=gcnew StreamReader(fstrm);
				sprites->Clear();
				String^ line;
				for(;;) {
					line=rd->ReadLine();
					if(line==nullptr)
						break;
					else
						sprites->Add(line);
				}
				rd->Close();
			} catch(System::Exception^ exp) {
				MessageBox::Show(this,exp->Message);
			}
		}
		openFileDialog1=nullptr;
		Cursor=System::Windows::Forms::Cursors::Arrow;
		saved=true;
		panel1->Invalidate();
	}


	private: System::Void buttonSave_Click(System::Object^  sender, System::EventArgs^  e) { //save sprite file
		//save sprites (palette info?)
		Cursor=System::Windows::Forms::Cursors::WaitCursor;
		SaveFileDialog^ saveFileDialog1 = gcnew SaveFileDialog();
		saveFileDialog1->FileName=Path::GetFileName(spritefilename);
		saveFileDialog1->Title="Save Sprite file";
		saveFileDialog1->InitialDirectory = Path::GetDirectoryName(spritefilename);
		saveFileDialog1->Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*" ;
		saveFileDialog1->FilterIndex = 1 ;
		saveFileDialog1->RestoreDirectory = true ;
		saveFileDialog1->DefaultExt="txt";
		saveFileDialog1->AddExtension=true;
		saveFileDialog1->OverwritePrompt=true;
			
		if(saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::OK) {
			spritefilename=saveFileDialog1->FileName;
			try {
				FileStream^ fstrm=gcnew FileStream(spritefilename,FileMode::Create);
				StreamWriter^ wr=gcnew StreamWriter(fstrm);
				for(int i=0;i<sprites->Count;i++)
					wr->WriteLine(sprites[i]->ToString());
				wr->Flush();
				wr->Close();
				saved=true;
			} catch(System::Exception^ exp) {
				MessageBox::Show(this,exp->Message);
			}
		}
		Cursor=System::Windows::Forms::Cursors::Arrow;
	}


	private: System::Void comboBoxView_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
		 trackBarZoom->Enabled=(comboBoxView->SelectedIndex==0||comboBoxView->SelectedIndex==1);
		 buttonAdd->Enabled=(comboBoxView->SelectedIndex==0||comboBoxView->SelectedIndex==3);
		 buttonBackPage->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonBackLine->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonFwdPage->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonFwdLine->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonReset->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonList->Enabled=(comboBoxView->SelectedIndex==0||comboBoxView->SelectedIndex==3);
		 buttonFwdNotEmpty->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonBackNotEmpty->Enabled=(comboBoxView->SelectedIndex==0);
 		 numericUpDownWidth->Enabled=(comboBoxView->SelectedIndex==0||comboBoxView->SelectedIndex==3);
 		 numericUpDownHeight->Enabled=(comboBoxView->SelectedIndex==0||comboBoxView->SelectedIndex==3);
 		 numericUpDownOffset->Enabled=(comboBoxView->SelectedIndex==0||comboBoxView->SelectedIndex==3);
		 comboBoxLayout->Enabled=(comboBoxView->SelectedIndex==0);
		 buttonLoadwh->Visible=(comboBoxView->SelectedIndex==3);
		 buttonLoadwhXOR->Visible=(comboBoxView->SelectedIndex==3);
		 buttonSkipwh->Visible=(comboBoxView->SelectedIndex==3);
		 buttonSkipXORwh->Visible=(comboBoxView->SelectedIndex==3);
		 comboBoxNumPrecedingBytes->Visible=(comboBoxView->SelectedIndex==3);
		 textBoxHexXORwh->Visible=(comboBoxView->SelectedIndex==3);
		 textBoxHexwh->Visible=(comboBoxView->SelectedIndex==3);
		 label7->Visible=(comboBoxView->SelectedIndex==3);
		 panel1->Invalidate();
	}


	private: System::Void comboBoxLayout_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
		panel1->Invalidate();
	}


	private: System::Void buttonFwdNotEmpty_Click(System::Object^  sender, System::EventArgs^  e) {
		int offset=Convert::ToInt32(numericUpDownOffset->Value);
		while(((buffer[offset]==0)||(buffer[offset]==0xff))&&offset<65535)
            offset++;
		numericUpDownOffset->Value=offset;
	}


	private: System::Void buttonBackNotEmpty_Click(System::Object^  sender, System::EventArgs^  e) {
		int offset=Convert::ToInt32(numericUpDownOffset->Value);
		while(((buffer[offset]==0)||(buffer[offset]==0xff))&&offset>0)
            offset--;
		numericUpDownOffset->Value=offset;
	}


	private: System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
		if(!saved)
			if(MessageBox::Show("Sprite list has not been saved.  Continue with exit?","Wms Gfx Ripper",MessageBoxButtons::YesNo,MessageBoxIcon::Question)==Windows::Forms::DialogResult::No)
				e->Cancel=true;
	}


	private: System::Void buttonLoadwh_Click(System::Object^  sender, System::EventArgs^  e) {
		int offset=Convert::ToInt32(numericUpDownOffset->Value);
		int numbytes=comboBoxNumPrecedingBytes->SelectedIndex;
		if(offset>=numbytes) {
			if(buffer[offset-numbytes]<152) {
				try {
					numericUpDownWidth->Value=buffer[offset-numbytes];
					numericUpDownHeight->Value=buffer[offset-numbytes+1];
				} catch(Exception^exp) {
					exp;
					MessageBox::Show("Invalid width (1-152)","Wms Gfx Ripper",MessageBoxButtons::OK,MessageBoxIcon::Exclamation);
				}
			} else
				MessageBox::Show("Invalid width (1-152)","Wms Gfx Ripper",MessageBoxButtons::OK,MessageBoxIcon::Exclamation);
		}
	}


	private: System::Void buttonLoadwhXOR_Click(System::Object^  sender, System::EventArgs^  e) {
		int offset=Convert::ToInt32(numericUpDownOffset->Value);
		int numbytes=comboBoxNumPrecedingBytes->SelectedIndex;
		if(offset>=numbytes) {
			if(buffer[offset-numbytes]<152) {
				try {
					numericUpDownWidth->Value=buffer[offset-numbytes]^4;
					numericUpDownHeight->Value=buffer[offset-numbytes+1]^4;
				} catch(Exception^exp) {
					exp;
					MessageBox::Show("Invalid width (1-152)","Wms Gfx Ripper",MessageBoxButtons::OK,MessageBoxIcon::Exclamation);
				}
			} else
				MessageBox::Show("Invalid width (1-152)","Wms Gfx Ripper",MessageBoxButtons::OK,MessageBoxIcon::Exclamation);
		}
	}


	private: System::Void buttonSkipwh_Click(System::Object^  sender, System::EventArgs^  e) {
		int cwidth;
		int cheight;
		int coffset=Convert::ToInt32(numericUpDownOffset->Value);
		int numbytes=comboBoxNumPrecedingBytes->SelectedIndex;
		if(coffset>=numbytes) {
			cwidth=buffer[coffset-numbytes];
			cheight=buffer[coffset-numbytes+1];
			coffset+=cwidth*cheight+numbytes;
			while(coffset<0)
				coffset+=65536;
			while(coffset>65535)
				coffset-=65536;
			numericUpDownOffset->Value=coffset;
		}
	}


	private: System::Void buttonSkipXORwh_Click(System::Object^  sender, System::EventArgs^  e) {
		int cwidth;
		int cheight;
		int coffset=Convert::ToInt32(numericUpDownOffset->Value);
		int numbytes=comboBoxNumPrecedingBytes->SelectedIndex;
		if(coffset>=numbytes) {
			cwidth=buffer[coffset-numbytes];
			cheight=buffer[coffset-numbytes+1];
			coffset+=(cwidth^4)*(cheight^4)+numbytes;
			while(coffset<0)
				coffset+=65536;
			while(coffset>65535)
				coffset-=65536;
			numericUpDownOffset->Value=coffset;
		}
	}


	private: System::Void comboBoxNumPrecedingBytes_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
		panel1->Invalidate();
	}


	private: System::Void panel1_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) {
		Graphics^ gr=e->Graphics;
		gr->Clear(Color::Black);
		int zoom=trackBarZoom->Value;
		if(comboBoxView->SelectedIndex==0) {  //view memory
			int width=Convert::ToInt32(numericUpDownWidth->Value);
			int height=Convert::ToInt32(numericUpDownHeight->Value);
			int offset=Convert::ToInt32(numericUpDownOffset->Value);
			drawsprite(gr,offset,width,height,0,0,comboBoxLayout->SelectedIndex==0,zoom);
		} else if(comboBoxView->SelectedIndex==1) {	//view sprites
			int maxheight=0;
			int curtop=0;
			int curleft=0;
			for(int i=0;i<sprites->Count;i++) {
				int width=Convert::ToInt32(sprites[i]->ToString()->Substring(57,3));
				if(curleft>0&&(curleft+width*2)*zoom>(panel1->Width)) {
					curtop+=maxheight+5;
					maxheight=0;
					curleft=0;
				}
				//draw sprite at curtop,curleft
				int offset=Convert::ToInt32(sprites[i]->ToString()->Substring(51,5));
				int height=Convert::ToInt32(sprites[i]->ToString()->Substring(61,3));
				drawsprite(gr,offset,width,height,curtop,curleft,sprites[i]->ToString()->Substring(65,1)=="L",zoom);
				curleft=curleft+width*2+5;
				if(height>maxheight)
					maxheight=height;
			}
		} else if(comboBoxView->SelectedIndex==2) {	//view palette
			System::Drawing::Font^ paletteFont=gcnew System::Drawing::Font("Arial",12,FontStyle::Regular,GraphicsUnit::Pixel);
			SolidBrush^ paletteBrush = gcnew SolidBrush(Color::White);
			SolidBrush^ textBrush = gcnew SolidBrush(Color::White);
			Pen^ textPen=gcnew Pen(Color::White);

			array<PointF>^points=gcnew array<PointF>(5);
			unsigned char r,g,b;

			for(int i=0;i<16;i++) {
				gr->DrawString(String::Format("{0:X1}",i),paletteFont,textBrush,static_cast<float>(72+i*30+3),10);
				gr->DrawString(String::Format("{0:X2}",colors[i]),paletteFont,textBrush,static_cast<float>(72+i*30-1),50);
				r=(colors[(i)&0xf]&0x7)<<1;
				if(r>6)
				 r++;
				g=(colors[(i)&0xf]&0x38)>>2;
				if(g>6)
				 g++;
				b=((colors[(i)&0xf]&0xc0)>>6)*5;
				paletteBrush=gcnew SolidBrush(Color::FromArgb(255,r<<4|r,g<<4|g,b<<4|b));
				points[0].X=static_cast<float>(70+i*30);
				points[0].Y=static_cast<float>(30);
				points[1].X=static_cast<float>(70+i*30+20);
				points[1].Y=static_cast<float>(30);
				points[2].X=static_cast<float>(70+i*30+20);
				points[2].Y=static_cast<float>(30+20);
				points[3].X=static_cast<float>(70+i*30);
				points[3].Y=static_cast<float>(30+20);
				points[4].X=static_cast<float>(70+i*30);
				points[4].Y=static_cast<float>(30);
				gr->FillPolygon(paletteBrush,points);

				//draw a white outline
				points[0].X-=1;
				points[0].Y-=1;
				points[1].Y-=1;
				points[3].X-=1;
				points[4].X-=1;
				points[4].Y-=1;
				gr->DrawPolygon(textPen,points);
			}
		} else if(comboBoxView->SelectedIndex==3) { //view hex

#define HEXTOP 50

			System::Drawing::Font^ textFont=gcnew System::Drawing::Font("Arial",12,FontStyle::Regular,GraphicsUnit::Pixel);
			SolidBrush^ textBrush = gcnew SolidBrush(Color::White);
			int offset=Convert::ToInt32(numericUpDownOffset->Value);

			int numbytes=comboBoxNumPrecedingBytes->SelectedIndex;
			if(offset>numbytes-1) {
				gr->DrawString(String::Format("{0:X4}:",offset-numbytes),textFont,textBrush,static_cast<float>(20),static_cast<float>(HEXTOP));
				for(int i=0;i<numbytes;i++)
					gr->DrawString(String::Format("{0:X2}",buffer[offset+i-numbytes]),textFont,textBrush,static_cast<float>(52+i*30-1+20),static_cast<float>(HEXTOP));
			}

			for(int j=0;j<16;j++) {
				gr->DrawString(String::Format("{0:X4}:",offset+j*16),textFont,textBrush,static_cast<float>(20),static_cast<float>(j*12+HEXTOP+30));
				for(int i=0;i<16;i++)
					gr->DrawString(String::Format("{0:X2}",buffer[offset+j*16+i]),textFont,textBrush,static_cast<float>(52+i*30-1+20),static_cast<float>(j*12+HEXTOP+30));
			}
			int width=Convert::ToInt32(numericUpDownWidth->Value);
			int height=Convert::ToInt32(numericUpDownHeight->Value);
			drawsprite(gr,offset,width,height,panel1->Height/4+panel1->Height/8-height/2,panel1->Width/4-width,comboBoxLayout->SelectedIndex==0,2);
			if(offset>=numbytes) {
				textBoxHexwh->Text=String::Concat(String::Format("{0:X2}",buffer[offset-numbytes])," ",String::Format("{0:X2}",buffer[offset-numbytes+1]));
				textBoxHexXORwh->Text=String::Concat(String::Format("{0:X2}",buffer[offset-numbytes]^4)," ",String::Format("{0:X2}",buffer[offset-numbytes+1]^4));
			} else {
				textBoxHexwh->Text="";
				textBoxHexXORwh->Text="";
			}
		}
	}
};
}
